Package org.eclipse.cdt.core.dom.ast

# Interface IASTAlignmentSpecifier

All Superinterfaces:
  `IASTNode`

All Known Subinterfaces:
  `ICPPASTAlignmentSpecifier`

public interface IASTAlignmentSpecifier extends IASTNode
Represents an alignment specifier. Grammatically, this is a decl-specifier in C and an attribute-specifier in C++. Possible forms are: C++: alignas(<type-id>) alignas(<expression>) C: _Alignas(<type-id>) _Alignas(<expression>)

Since:
  5.10
Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`IASTNode.CopyStyle`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final ASTNodeProperty`
`ALIGNMENT_EXPRESSION`
`static final ASTNodeProperty`
`ALIGNMENT_TYPEID`
`static final IASTAlignmentSpecifier[]`
`EMPTY_ALIGNMENT_SPECIFIER_ARRAY`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`EMPTY_NODE_ARRAY`

## Method Summary

Modifier and Type
Method
Description
`IASTAlignmentSpecifier`
`copy()`
Returns a mutable copy of the tree rooted at this node.
`IASTAlignmentSpecifier`
`copy(IASTNode.CopyStyle style)`
Returns a mutable copy of the tree rooted at this node.
`IASTExpression`
`getExpression()`
If the specifier is of the form 'alignas(<expression>)' or '_Alignas(<expression>)', returns the enclosed expression.
`IASTTypeId`
`getTypeId()`
If the specifier is of the form 'alignas(<type-id>)' or '_Alignas(<type-id>)', returns the enclosed type-id.

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`accept, contains, getChildren, getContainingFilename, getFileLocation, getLeadingSyntax, getNodeLocations, getOriginalNode, getParent, getPropertyInParent, getRawSignature, getSyntax, getTrailingSyntax, getTranslationUnit, isActive, isFrozen, isPartOfTranslationUnitFile, setParent, setPropertyInParent`

## Field Details

### EMPTY_ALIGNMENT_SPECIFIER_ARRAY

static final IASTAlignmentSpecifier[] EMPTY_ALIGNMENT_SPECIFIER_ARRAY

### ALIGNMENT_EXPRESSION

static final ASTNodeProperty ALIGNMENT_EXPRESSION

### ALIGNMENT_TYPEID

static final ASTNodeProperty ALIGNMENT_TYPEID

## Method Details

### getExpression

IASTExpression getExpression()
If the specifier is of the form 'alignas(<expression>)' or '_Alignas(<expression>)', returns the enclosed expression. Otherwise, returns null.

### getTypeId

IASTTypeId getTypeId()
If the specifier is of the form 'alignas(<type-id>)' or '_Alignas(<type-id>)', returns the enclosed type-id. Otherwise, returns null.

### copy

IASTAlignmentSpecifier copy()
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Calling this method is equivalent to `copy(CopyStyle.withoutLocations)`.

Specified by:
  `copy` in interface `IASTNode`

### copy

IASTAlignmentSpecifier copy(IASTNode.CopyStyle style)
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Specified by:
  `copy` in interface `IASTNode`
Parameters:
  `style` - `IASTNode.CopyStyle` create a copy with or without locations. Please see `IASTNode.CopyStyle` for restrictions on copies with Locations.